Subject: [RFC PATCH 0/3] ARM: amba: defining module aliases for AMBA driver autoloading

From: [email-masked] (Dave Martin)
Date: Mon, 3 Oct 2011 13:19:15 +0100

On Sat, Oct 01, 2011 at 05:46:55PM +0100, Russell King - ARM Linux wrote:
> On Fri, Sep 30, 2011 at 05:56:39PM +0100, Dave Martin wrote:
> > Issues:
> > 
> >   * Do new module alises need to be globally agreed/registered
> >     somewhere?
> 
> I don't think there is.  Having the bus prefix in there is definitely a
> good thing.

OK, I'll stick with "amba:" for now, then.

> >   * Because a driver's ID table is in match-and-mask format whereas
> >     udev uses string pattern matching, we effectively have to
> >     maintain two ID tables per driver, containing the same
> >     information in different formats.  The patch to mmci.c gives an
> >     example.
> > 
> >     I predict that maintenance of those duplicated tables will be
> >     somewhat painful and error-prone.  However, the necessary
> >     transformations, while simple, are beyond the scope of the C
> >     preprocessor.
> > 
> >     In order to avoid this duplication of information, an extra
> >     (but simple) bit of build-time infrastructure would be needed.
> > 
> >     I think this effort would be worth it -- does anyone have
> >     strong views on this?
> 
> I think there is some support for udev to use PCI ID tables directly.
> I don't know how that works - I suspect it requires module tools
> support though.  Might be worth investigating.

Hmmm, it looks like there's some magic for other bus types like PCI and
USB, where some scripting generates appropriate module aliases from
drivers' device tables (see scripts/mod/file2alias.c)

I'll see whether we can hook into that.  This would allow us to avoid
having to describe the aliases explicitly.

Thanks for the feedback.

Cheers
---Dave